# `makeDropzone(GraphicComponent): DropzoneComponent`

High order component for easy making of file upload component with file dropzone.

### Arguments
1. `GraphicComponent`: React component that creates dropzone graphic.

### Returns
Component that receives two extra props:
1. `isMouseOver` (boolean): Determine if user drags with mouse over zone. Useful for changing dropzone style.
2. `uploadState` ([FS](#file-state)): Actual state of file upload


### File State

```ts
enum FS {
    failed,
    pending,
    uploading,
    uploaded
}
```


### Examples

```jsx
import makeDropzone, { FS } from 'ackee-frontend-toolkit/lib/HOC/makeDropzone';

makeDropzone(({ isMouseOver, uploadState }) => (
    <div style={{ backgroundColor: isMouseOver ? 'yellow' : 'grey' }}>
        <span className="button--blue button">
            {uploadState === FS.uploaded || uploadState === FS.failed ? 'Change' : 'Select'}
        </span>
    </div>
));
```
