# getDisplayName helper

Helper useful when creating your own High Order Component. It's taken from [original reactjs documention
about HOCs](https://reactjs.org/docs/higher-order-components.html#convention-wrap-the-display-name-for-easy-debugging)

#### Examples

```js
import { getDisplayName } from 'ackee-frontend-toolkit/lib/helpers';

const withSubscriptionHOC = (WrappedComponent) => {
    class WithSubscription extends React.Component {
        static displayName = `WithSubscription(${getDisplayName(WrappedComponent)})`;
        
        /* ... */
    }
  
    return WithSubscription;
}
```
