### `combineDependenciesHandlers(...handlersObjects)`

Helper to combine dependencies handlers for `runRouteDependecies`. Accepts infinite number of handlers objects `({'template': sagaHandler})` and returns exactly one for usage in `runRouteDependecies`. Supports same keys in the handlers objects

#### Usage

```javascript
// in runRouteDependecies.js file:
import { routeHandlers as usersHandlers } from 'Modules/users';
import { routeHandlers as bookingsHandlers } from 'Modules/bookings';
import { routeHandlers as reviewsHandlers } from 'Modules/reviews';

export const appHandlers = {
    '/': appSaga,
    '/logout': function* () {
        // do some logic on when /logout route is visited
    },
};

const handlers = combineDependenciesHandlers(
    appHandlers,
    usersHandlers,
    bookingsHandlers
    reviewsHandlers
);
```

Each module can have its own `routeHandlers` object and the `combineDependenciesHandlers` utility handles their merging.

#### Usage examples

-   [Petshare](https://gitlab.ack.ee/Web/petshare-web) - see `routeActionsSaga.js` file
