function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import _ from 'lodash';

import getDisplayName from '../helpers/componentName';

var loadableFactory = function loadableFactory(LoaderComponent) {
    var defaultLoaderText = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    return function (LoadableComponent) {
        var ComponentWithLoader = function ComponentWithLoader(_ref) {
            var showLoader = _ref.showLoader,
                loaderText = _ref.loaderText,
                props = _objectWithoutProperties(_ref, ['showLoader', 'loaderText']);

            return React.createElement(
                LoaderComponent,
                { show: showLoader, text: loaderText },
                React.createElement(LoadableComponent, _.omit(props, ['children']))
            );
        };

        ComponentWithLoader.displayName = 'Loadable(' + getDisplayName(LoadableComponent) + ')';
        ComponentWithLoader.propTypes = {
            showLoader: PropTypes.bool.isRequired,
            loaderText: PropTypes.node
        };

        ComponentWithLoader.defaultProps = {
            loaderText: defaultLoaderText
        };

        return ComponentWithLoader;
    };
};

export default loadableFactory;