var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { React, PropTypes, getDisplayName } from '../dependencies';

var conversationHolder = function conversationHolder(ConversationComponent) {
    var _class, _temp;

    return _temp = _class = function (_React$Component) {
        _inherits(ConversationHolder, _React$Component);

        function ConversationHolder() {
            _classCallCheck(this, ConversationHolder);

            return _possibleConstructorReturn(this, (ConversationHolder.__proto__ || Object.getPrototypeOf(ConversationHolder)).apply(this, arguments));
        }

        _createClass(ConversationHolder, [{
            key: 'componentDidMount',
            value: function componentDidMount() {
                this.notifyEnterConversation();
            }
        }, {
            key: 'componentWillUpdate',
            value: function componentWillUpdate(nextProps) {
                if (nextProps.conversationId !== this.props.conversationId) {
                    this.notifyLeaveConversation();
                }
            }
        }, {
            key: 'componentDidUpdate',
            value: function componentDidUpdate(prevProps) {
                if (prevProps.conversationId !== this.props.conversationId) {
                    this.notifyEnterConversation();
                }
            }
        }, {
            key: 'componentWillUnmount',
            value: function componentWillUnmount() {
                this.notifyLeaveConversation();
            }
        }, {
            key: 'notifyEnterConversation',
            value: function notifyEnterConversation() {
                this.props.actions.conversationEnter(this.props.conversationId, this.props.userId);
            }
        }, {
            key: 'notifyLeaveConversation',
            value: function notifyLeaveConversation() {
                this.props.actions.conversationLeave(this.props.conversationId, this.props.userId);
            }
        }, {
            key: 'render',
            value: function render() {
                var _props$actions = this.props.actions,
                    conversationEnter = _props$actions.conversationEnter,
                    conversationLeave = _props$actions.conversationLeave,
                    restActions = _objectWithoutProperties(_props$actions, ['conversationEnter', 'conversationLeave']);

                return React.createElement(ConversationComponent, _extends({}, this.props, { actions: restActions }));
            }
        }]);

        return ConversationHolder;
    }(React.Component), _class.displayName = 'ConversationHolder(' + getDisplayName(ConversationComponent) + ')', _class.propTypes = {
        conversationId: PropTypes.string.isRequired,
        userId: PropTypes.string.isRequired,
        actions: PropTypes.shape({
            conversationEnter: PropTypes.func.isRequired,
            conversationLeave: PropTypes.func.isRequired
        }).isRequired
    }, _temp;
};

export default conversationHolder;