var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { React, PropTypes, FormattedMessage } from '../../dependencies';

var FileUpload = function (_React$Component) {
    _inherits(FileUpload, _React$Component);

    function FileUpload() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, FileUpload);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FileUpload.__proto__ || Object.getPrototypeOf(FileUpload)).call.apply(_ref, [this].concat(args))), _this), _this.handleFileUploadOpen = function (event) {
            event.preventDefault();
            _this.fileInput.click();
        }, _this.handleFileUpload = function (event) {
            var files = event.target.files;
            var _this$props = _this.props,
                onUploadFile = _this$props.onUploadFile,
                conversationId = _this$props.conversationId,
                userId = _this$props.userId,
                supportedTypes = _this$props.supportedTypes;


            if (files && files[0]) {
                var type = files[0].type;

                if (supportedTypes.includes(type)) {
                    onUploadFile(conversationId, userId, files[0]);
                } else {
                    // TODO - how to notify unsupported format
                }
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(FileUpload, [{
        key: "render",
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                disabled = _props.disabled,
                uploadLabel = _props.uploadLabel;


            return React.createElement(
                React.Fragment,
                null,
                React.createElement("input", {
                    onChange: this.handleFileUpload,
                    ref: function ref(node) {
                        _this2.fileInput = node;
                    },
                    type: "file"
                }),
                React.createElement(
                    "button",
                    {
                        disabled: disabled,
                        type: "button",
                        onClick: this.handleFileUploadOpen
                    },
                    uploadLabel
                )
            );
        }
    }]);

    return FileUpload;
}(React.Component);

FileUpload.propTypes = {
    userId: PropTypes.string.isRequired,
    conversationId: PropTypes.string.isRequired,
    supportedTypes: PropTypes.arrayOf(PropTypes.string),
    uploadLabel: PropTypes.node,
    disabled: PropTypes.node,
    onUploadFile: PropTypes.func.isRequired
};

FileUpload.defaultProps = {
    supportedTypes: ['image/jpg', 'image/jpeg', 'image/png', 'image/gif'],
    uploadLabel: React.createElement(FormattedMessage, { id: "chat.message.new.upload" }),
    disabled: false
};

export default FileUpload;