import { connect, compose, bindActionCreators } from '../dependencies';

import { isConversationLoadedSelector } from '../services/selectors';
import { conversationEnter, conversationLeave } from '../services/actions';

import conversationHolder from '../HOC/conversationHolder';
import Conversation from '../components/Conversations/Conversation';

import { conversationConnect } from '../services/firebase/connects';

var mapStateToProps = function mapStateToProps(state, props) {
    return {
        isLoaded: isConversationLoadedSelector(state, props)
    };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {
        actions: bindActionCreators({
            conversationEnter: conversationEnter,
            conversationLeave: conversationLeave
        }, dispatch)
    };
};

export default compose(connect(mapStateToProps, mapDispatchToProps), conversationConnect, conversationHolder)(Conversation);