var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { connect, bindActionCreators, compose } from '../dependencies';

import { messagesSelector, messagesCountsSelector, isUserConversationsLoaded } from '../services/selectors';

import { incChatPage, conversationMessagesLoaded } from '../services/actions';
import { conversationMessagesConnect } from '../services/firebase/connects';

import Messages from '../components/Messages/Messages';

var mapStateToProps = function mapStateToProps(state, props) {
    var messages = messagesSelector(state, props);

    return _extends({}, messagesCountsSelector(state, props), messages, {
        isLoaded: messages.isLoaded && isUserConversationsLoaded(state, props)
    });
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return bindActionCreators({
        incChatPage: incChatPage,
        conversationMessagesLoaded: conversationMessagesLoaded
    }, dispatch);
};

export default compose(connect(mapStateToProps, mapDispatchToProps), conversationMessagesConnect)(Messages);