import types from '../actionTypes';

export function createMessage() {
    return {
        type: types.CREATE_TEXT_MESSAGE
    };
}

export function uploadImage(conversationId, userId, image) {
    return {
        type: types.CREATE_IMAGE_MESSAGE,
        conversationId: conversationId,
        userId: userId,
        image: image
    };
}

export function searchConversations() {
    return {
        type: types.SEARCH_CONVERSATIONS
    };
}

export function setSeenMessages(conversationId, userId) {
    return {
        type: types.SET_SEEN_MESSAGES,
        conversationId: conversationId,
        userId: userId
    };
}

export function toggleUserOnline(online) {
    return {
        type: types.TOGGLE_USER_ONLINE,
        online: online
    };
}

export function incChatPage() {
    return {
        type: types.INC_CHAT
    };
}

export function incSentMessages() {
    return {
        type: types.INC_SENT_MESSAGES
    };
}

export var conversationEnter = function conversationEnter(conversationId, userId) {
    return {
        type: types.CONVERSATION_ENTER,
        conversationId: conversationId,
        userId: userId
    };
};

export var conversationLeave = function conversationLeave(conversationId, userId) {
    return {
        type: types.CONVERSATION_LEAVE,
        conversationId: conversationId,
        userId: userId
    };
};

export var conversationMessagesLoaded = function conversationMessagesLoaded(conversationId, firstUnreadMessageId) {
    return {
        type: types.CONVERSATION_MESSAGES_LOADED,
        conversationId: conversationId,
        firstUnreadMessageId: firstUnreadMessageId
    };
};