'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _componentName = require('../helpers/componentName');

var _componentName2 = _interopRequireDefault(_componentName);

var _loggingActions = require('../actions/loggingActions');

var loggingActions = _interopRequireWildcard(_loggingActions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var errorBoundary = function errorBoundary(ErrorComponent) {
    return function (ComponentToBound) {
        var ErrorBoundary = function (_React$Component) {
            _inherits(ErrorBoundary, _React$Component);

            function ErrorBoundary(props) {
                _classCallCheck(this, ErrorBoundary);

                var _this = _possibleConstructorReturn(this, (ErrorBoundary.__proto__ || Object.getPrototypeOf(ErrorBoundary)).call(this, props));

                _this.state = {
                    error: null
                };
                return _this;
            }

            _createClass(ErrorBoundary, [{
                key: 'componentDidCatch',
                value: function componentDidCatch(error, errorInfo) {
                    this.setState({ error: error });
                    this.props.logError(error, { extra: errorInfo });
                }
            }, {
                key: 'render',
                value: function render() {
                    var error = this.state.error;

                    return error ? _react2.default.createElement(ErrorComponent, _extends({}, this.props, { error: error })) : _react2.default.createElement(ComponentToBound, this.props);
                }
            }]);

            return ErrorBoundary;
        }(_react2.default.Component);

        ErrorBoundary.displayName = 'ErrorBoundary(' + (0, _componentName2.default)(ComponentToBound) + ')';
        ErrorBoundary.propTypes = {
            logError: _propTypes2.default.func.isRequired
        };


        return (0, _reactRedux.connect)(null, function (dispatch) {
            return {
                logError: (0, _redux.bindActionCreators)(loggingActions.logError, dispatch)
            };
        })(ErrorBoundary);
    };
};

exports.default = errorBoundary;