'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _componentName = require('../helpers/componentName');

var _componentName2 = _interopRequireDefault(_componentName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var loadableFactory = function loadableFactory(LoaderComponent) {
    var defaultLoaderText = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    return function (LoadableComponent) {
        var ComponentWithLoader = function ComponentWithLoader(_ref) {
            var showLoader = _ref.showLoader,
                loaderText = _ref.loaderText,
                props = _objectWithoutProperties(_ref, ['showLoader', 'loaderText']);

            return _react2.default.createElement(
                LoaderComponent,
                { show: showLoader, text: loaderText },
                _react2.default.createElement(LoadableComponent, _lodash2.default.omit(props, ['children']))
            );
        };

        ComponentWithLoader.displayName = 'Loadable(' + (0, _componentName2.default)(LoadableComponent) + ')';
        ComponentWithLoader.propTypes = {
            showLoader: _propTypes2.default.bool.isRequired,
            loaderText: _propTypes2.default.node
        };

        ComponentWithLoader.defaultProps = {
            loaderText: defaultLoaderText
        };

        return ComponentWithLoader;
    };
};

exports.default = loadableFactory;