'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DataListElement = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCustomScrollbars = require('react-custom-scrollbars');

var _propTypes3 = require('./propTypes');

var _pure = require('../HOC/pure');

var _pure2 = _interopRequireDefault(_pure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var dataListClassName = 'widget-data-list';

var Thumb = function Thumb(_ref) {
    var props = _objectWithoutProperties(_ref, []);

    return _react2.default.createElement('div', _extends({}, props, { className: dataListClassName + '__scrollbar-thumb' }));
};

var NoDataMessage = function NoDataMessage(_ref2) {
    var message = _ref2.message;
    return _react2.default.createElement(
        'div',
        { className: dataListClassName + '__no-data-message' },
        message
    );
};

NoDataMessage.propTypes = {
    message: _propTypes2.default.node.isRequired
};

var DataListElement = function DataListElement(_ref3) {
    var Element = _ref3.Element,
        children = _ref3.children,
        props = _objectWithoutProperties(_ref3, ['Element', 'children']);

    return Element ? _react2.default.createElement(
        Element,
        props,
        children
    ) : _react2.default.createElement(
        'table',
        props,
        _react2.default.createElement(
            'tbody',
            null,
            children
        )
    );
};

exports.DataListElement = DataListElement;
DataListElement.propTypes = {
    Element: _propTypes2.default.string,
    children: _propTypes3.childrenPropType
};

DataListElement.defaultProps = {
    Element: null,
    children: null
};

/* eslint-disable react/no-array-index-key */
var DataList = function DataList(_ref4) {
    var data = _ref4.data,
        noDataMessage = _ref4.noDataMessage,
        RowComponent = _ref4.RowComponent,
        element = _ref4.element,
        scrollable = _ref4.scrollable;

    if (data.length === 0) {
        return _react2.default.createElement(NoDataMessage, { message: noDataMessage });
    }

    var body = _react2.default.createElement(
        DataListElement,
        { className: dataListClassName, Element: element },
        data.map(function (rowData, index) {
            return _react2.default.isValidElement(RowComponent) ? _react2.default.cloneElement(RowComponent, _extends({
                key: 'row' + index,
                index: index
            }, rowData)) : _react2.default.createElement(RowComponent, _extends({
                key: 'row' + index,
                index: index
            }, rowData));
        })
    );

    if (!scrollable) {
        return body;
    }

    return _react2.default.createElement(
        _reactCustomScrollbars.Scrollbars,
        {
            renderThumbHorizontal: Thumb,
            renderThumbVertical: Thumb,
            className: dataListClassName + '-scrollbars'
        },
        body
    );
};

DataList.propTypes = {
    data: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
    RowComponent: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.element]).isRequired,
    noDataMessage: _propTypes2.default.node,
    scrollable: _propTypes2.default.bool,
    element: _propTypes2.default.string
};

DataList.defaultProps = {
    scrollable: true,
    noDataMessage: 'Empty data',
    element: null
};

exports.default = (0, _pure2.default)()(DataList);