'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _dependencies = require('../dependencies');

var _selectors = require('../services/selectors');

var _actions = require('../services/actions');

var _conversationHolder = require('../HOC/conversationHolder');

var _conversationHolder2 = _interopRequireDefault(_conversationHolder);

var _Conversation = require('../components/Conversations/Conversation');

var _Conversation2 = _interopRequireDefault(_Conversation);

var _connects = require('../services/firebase/connects');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state, props) {
    return {
        isLoaded: (0, _selectors.isConversationLoadedSelector)(state, props)
    };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {
        actions: (0, _dependencies.bindActionCreators)({
            conversationEnter: _actions.conversationEnter,
            conversationLeave: _actions.conversationLeave
        }, dispatch)
    };
};

exports.default = (0, _dependencies.compose)((0, _dependencies.connect)(mapStateToProps, mapDispatchToProps), _connects.conversationConnect, _conversationHolder2.default)(_Conversation2.default);