'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dependencies = require('../dependencies');

var _selectors = require('../services/selectors');

var _actions = require('../services/actions');

var _connects = require('../services/firebase/connects');

var _Messages = require('../components/Messages/Messages');

var _Messages2 = _interopRequireDefault(_Messages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state, props) {
    var messages = (0, _selectors.messagesSelector)(state, props);

    return _extends({}, (0, _selectors.messagesCountsSelector)(state, props), messages, {
        isLoaded: messages.isLoaded && (0, _selectors.isUserConversationsLoaded)(state, props)
    });
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return (0, _dependencies.bindActionCreators)({
        incChatPage: _actions.incChatPage,
        conversationMessagesLoaded: _actions.conversationMessagesLoaded
    }, dispatch);
};

exports.default = (0, _dependencies.compose)((0, _dependencies.connect)(mapStateToProps, mapDispatchToProps), _connects.conversationMessagesConnect)(_Messages2.default);