'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.conversationMessagesLoaded = exports.conversationLeave = exports.conversationEnter = undefined;
exports.createMessage = createMessage;
exports.uploadImage = uploadImage;
exports.searchConversations = searchConversations;
exports.setSeenMessages = setSeenMessages;
exports.toggleUserOnline = toggleUserOnline;
exports.incChatPage = incChatPage;
exports.incSentMessages = incSentMessages;

var _actionTypes = require('../actionTypes');

var _actionTypes2 = _interopRequireDefault(_actionTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createMessage() {
    return {
        type: _actionTypes2.default.CREATE_TEXT_MESSAGE
    };
}

function uploadImage(conversationId, userId, image) {
    return {
        type: _actionTypes2.default.CREATE_IMAGE_MESSAGE,
        conversationId: conversationId,
        userId: userId,
        image: image
    };
}

function searchConversations() {
    return {
        type: _actionTypes2.default.SEARCH_CONVERSATIONS
    };
}

function setSeenMessages(conversationId, userId) {
    return {
        type: _actionTypes2.default.SET_SEEN_MESSAGES,
        conversationId: conversationId,
        userId: userId
    };
}

function toggleUserOnline(online) {
    return {
        type: _actionTypes2.default.TOGGLE_USER_ONLINE,
        online: online
    };
}

function incChatPage() {
    return {
        type: _actionTypes2.default.INC_CHAT
    };
}

function incSentMessages() {
    return {
        type: _actionTypes2.default.INC_SENT_MESSAGES
    };
}

var conversationEnter = exports.conversationEnter = function conversationEnter(conversationId, userId) {
    return {
        type: _actionTypes2.default.CONVERSATION_ENTER,
        conversationId: conversationId,
        userId: userId
    };
};

var conversationLeave = exports.conversationLeave = function conversationLeave(conversationId, userId) {
    return {
        type: _actionTypes2.default.CONVERSATION_LEAVE,
        conversationId: conversationId,
        userId: userId
    };
};

var conversationMessagesLoaded = exports.conversationMessagesLoaded = function conversationMessagesLoaded(conversationId, firstUnreadMessageId) {
    return {
        type: _actionTypes2.default.CONVERSATION_MESSAGES_LOADED,
        conversationId: conversationId,
        firstUnreadMessageId: firstUnreadMessageId
    };
};