'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.conversationConnect = exports.conversationMessagesConnect = exports.userConversationsConnect = undefined;

var _reactReduxFirebase = require('react-redux-firebase');

var _paths = require('./paths');

var userConversationsConnect = exports.userConversationsConnect = (0, _reactReduxFirebase.firebaseConnect)(function (props) {
    return [{
        path: (0, _paths.userConversations)(props.userId).path,
        populates: _paths.populates.conversations
    }, (0, _paths.users)().path];
});

var conversationMessagesConnect = exports.conversationMessagesConnect = (0, _reactReduxFirebase.firebaseConnect)(function (_ref) {
    var conversationId = _ref.conversationId,
        count = _ref.count,
        disabledPaging = _ref.disabledPaging;
    return [conversationId && {
        path: (0, _paths.conversationMessages)(conversationId).path,
        populates: _paths.populates.messages,
        queryParams: disabledPaging ? [] : ['limitToLast=' + count]
    }].filter(function (path) {
        return !!path;
    });
});

var conversationConnect = exports.conversationConnect = (0, _reactReduxFirebase.firebaseConnect)(function (props) {
    return [(0, _paths.conversation)(props.id).path];
});