'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.sendMessage = sendMessage;
exports.createTextMessage = createTextMessage;
exports.setSeenMessages = setSeenMessages;
exports.default = _callee;

var _dependencies = require('../../dependencies');

var _actionTypes = require('../actionTypes');

var _actionTypes2 = _interopRequireDefault(_actionTypes);

var _actions = require('../actions');

var chatActions = _interopRequireWildcard(_actions);

var _paths = require('../firebase/paths');

var paths = _interopRequireWildcard(_paths);

var _selectors = require('../selectors');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = /*#__PURE__*/regeneratorRuntime.mark(sendMessage),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(createTextMessage),
    _marked3 = /*#__PURE__*/regeneratorRuntime.mark(setSeenMessages),
    _marked4 = /*#__PURE__*/regeneratorRuntime.mark(_callee);

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function sendMessage(conversationId, message, unseen, reset) {
    var _getFirebase$database;

    var key;
    return regeneratorRuntime.wrap(function sendMessage$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    if (!(typeof reset === 'function')) {
                        _context.next = 3;
                        break;
                    }

                    _context.next = 3;
                    return reset();

                case 3:
                    key = (0, _dependencies.getFirebase)().database().ref(paths.conversationMessages(conversationId).path).push().key;
                    _context.next = 6;
                    return (0, _dependencies.getFirebase)().database().ref().update((_getFirebase$database = {}, _defineProperty(_getFirebase$database, paths.conversationMessages(conversationId).path + '/' + key, _extends({}, message, {
                        unseen: unseen
                    })), _defineProperty(_getFirebase$database, paths.conversationLastMessage(conversationId).path, message), _getFirebase$database));

                case 6:
                    _context.next = 8;
                    return (0, _dependencies.effectPut)(chatActions.setSeenMessages(conversationId));

                case 8:
                    _context.next = 10;
                    return (0, _dependencies.effectPut)(chatActions.incSentMessages());

                case 10:
                case 'end':
                    return _context.stop();
            }
        }
    }, _marked, this);
}

function createTextMessage(params) {
    var _params$data, userId, conversationId, text, reset, startSubmit, stopSubmit, unseen, message;

    return regeneratorRuntime.wrap(function createTextMessage$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    _params$data = params.data, userId = _params$data.userId, conversationId = _params$data.conversationId, text = _params$data.text, reset = params.reset, startSubmit = params.startSubmit, stopSubmit = params.stopSubmit;
                    _context2.next = 3;
                    return (0, _dependencies.effectSelect)(_selectors.unseenSelector, { userId: userId, conversationId: conversationId });

                case 3:
                    unseen = _context2.sent;
                    message = {
                        author: userId,
                        time: new Date().getTime(),
                        text: text
                    };
                    _context2.next = 7;
                    return sendMessage(conversationId, message, unseen, reset);

                case 7:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _marked2, this);
}

function setSeenMessages(_ref) {
    var conversationId = _ref.conversationId,
        userId = _ref.userId;

    var ref, _ref2, messages, refs;

    return regeneratorRuntime.wrap(function setSeenMessages$(_context3) {
        while (1) {
            switch (_context3.prev = _context3.next) {
                case 0:
                    ref = '' + paths.conversationMessages(conversationId).path;
                    _context3.next = 3;
                    return (0, _dependencies.effectSelect)(_selectors.messagesSelector, {
                        userId: userId,
                        conversationId: conversationId
                    });

                case 3:
                    _ref2 = _context3.sent;
                    messages = _ref2.messages;

                    if (!(messages && userId)) {
                        _context3.next = 10;
                        break;
                    }

                    refs = messages.reduce(function (allRefs, message) {
                        if ((0, _dependencies._get)(message, ['unseen', userId]) !== undefined) {
                            allRefs['/' + message.messageId + '/unseen/' + userId] = null;
                        }
                        return allRefs;
                    }, {});

                    if ((0, _dependencies._isEmpty)(refs)) {
                        _context3.next = 10;
                        break;
                    }

                    _context3.next = 10;
                    return (0, _dependencies.getFirebase)().database().ref(ref).update(refs);

                case 10:
                case 'end':
                    return _context3.stop();
            }
        }
    }, _marked3, this);
}

var handlers = _defineProperty({}, _actionTypes2.default.CREATE_TEXT_MESSAGE, createTextMessage);

function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context4) {
        while (1) {
            switch (_context4.prev = _context4.next) {
                case 0:
                    _context4.next = 2;
                    return (0, _dependencies.effectAll)([(0, _dependencies.runSagas)(handlers), (0, _dependencies.effectTakeEvery)(_actionTypes2.default.SET_SEEN_MESSAGES, setSeenMessages)]);

                case 2:
                    return _context4.abrupt('return', _context4.sent);

                case 3:
                case 'end':
                    return _context4.stop();
            }
        }
    }, _marked4, this);
}