'use strict';

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactIntl = require('react-intl');

var _cs = require('react-intl/locale-data/cs');

var _cs2 = _interopRequireDefault(_cs);

var _cs_CZ = require('antd/lib/locale-provider/cs_CZ');

var _cs_CZ2 = _interopRequireDefault(_cs_CZ);

var _en_US = require('antd/lib/locale-provider/en_US');

var _en_US2 = _interopRequireDefault(_en_US);

var _antd = require('antd');

var _react3 = require('@storybook/react');

require('antd/es/pagination/style/index.less');

var _ = require('..');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

(0, _reactIntl.addLocaleData)([].concat(_toConsumableArray(_cs2.default)));

var messages = {
    cs: {
        foo: 'Ano, ja jsem foo',
        'bar.baz': 'Ne, ja jsem bar baz'
    },
    en: {
        foo: 'Yeah, I am foo',
        'bar.baz': 'No, I am baz'
    }
};

var antdLocales = {
    cs: _cs_CZ2.default,
    en: _en_US2.default
};

var initialState = {
    translate: { locale: 'cs' }
};
var store = (0, _redux.createStore)(function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    if (action.type === 'CHANGE_LOCALE') {
        return {
            translate: { locale: action.locale }
        };
    }
    return state;
});

var localeChangeHandler = function localeChangeHandler(e) {
    return store.dispatch({ type: 'CHANGE_LOCALE', locale: e.target.value });
};

var ContentComponent = function ContentComponent(_ref) {
    var locale = _ref.locale;
    return _react2.default.createElement(
        'div',
        null,
        ['cs', 'en'].map(function (lang) {
            return _react2.default.createElement(
                'div',
                { key: lang },
                lang,
                ' ',
                _react2.default.createElement('input', {
                    type: 'radio',
                    name: 'locale',
                    value: lang,
                    checked: lang === locale,
                    onChange: localeChangeHandler
                })
            );
        }),
        _react2.default.createElement(_antd.Pagination, { defaultCurrent: 1, total: 50, showSizeChanger: true }),
        _react2.default.createElement(
            'h1',
            null,
            _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'foo' })
        ),
        _react2.default.createElement(
            'h2',
            null,
            _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'bar.baz' })
        )
    );
};

ContentComponent.propTypes = {
    locale: _propTypes2.default.string.isRequired
};

(0, _react3.storiesOf)('Modules|localization/translatable', module).add('simple', function () {
    var TranslatableComponent = (0, _.translatableHOC)(messages, antdLocales)(ContentComponent);
    return _react2.default.createElement(TranslatableComponent, { store: store });
});