'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.handleError = handleError;
exports.default = errorSaga;

var _effects = require('redux-saga/effects');

var _marked = /*#__PURE__*/regeneratorRuntime.mark(handleError),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(errorSaga);

function isFailedAction(_action) {
    return _action.type.indexOf('_FAILED') > -1;
}

function handleError(action) {
    return regeneratorRuntime.wrap(function handleError$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    _context.next = 2;
                    return console.warn(action.error);

                case 2:
                case 'end':
                    return _context.stop();
            }
        }
    }, _marked, this);
}

function errorSaga(customHandler) {
    return regeneratorRuntime.wrap(function errorSaga$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    _context2.next = 2;
                    return (0, _effects.takeEvery)(isFailedAction, customHandler || handleError);

                case 2:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _marked2, this);
}