import firebasemock from 'firebase-mock';
import { combineReducers, createStore, applyMiddleware, compose } from 'redux';
import { reactReduxFirebase as firebaseEnhancer } from 'react-redux-firebase';

const firebase = new firebasemock.MockFirebaseSdk();

firebase.initializeApp({});

export default function configureStore(
    initialState,
    reducer,
    ...customMiddlewares
) {
    const middlewares = [...customMiddlewares].filter(m => !!m);

    const middleware = applyMiddleware(...middlewares);
    const enhancer = compose(
        middleware,
        firebaseEnhancer(firebase, { enableLogging: false }),
        window.devToolsExtension ? window.devToolsExtension() : r => r,
    );

    const store = createStore(combineReducers(reducer), initialState, enhancer);

    return store;
}
